IF NOT EXISTS (SELECT * FROM sys.schemas WHERE name = 'AO')
BEGIN
EXEC('CREATE SCHEMA AO')
END
GO

CREATE OR ALTER PROCEDURE [AO].[ExcelDodajTabeleUserow]
as
Create table AO.ExcelUsers
(
	Id int Identity,
	Login varchar(max) NOT NULL,
	Password varchar(max) NOT NULL,
	IsSuperUser bit default 0,
	CreateDate datetime default GetDate(),
	Primary key(Id)
);
GO

CREATE OR ALTER PROCEDURE [AO].[ExcelDodajTabeleSzablonow]
AS

create  table [AO].[PRP_Excel2SQL_Queries](
Preg_Id int NOT Null IDENTITY(1,1) PRIMARY KEY ,
Preg_Name varchar(40),
Preg_TextReg varchar(max),
Preg_CreateData datetime,
Preg_ModData datetime,
Preg_User varchar(30),
Preg_SPID int
);
GO


CREATE OR ALTER PROCEDURE [AO].[ExcelDodajTabeleUser_Szablon]
as
CREATE TABLE AO.User_Szablon
(
	UserId INT not null,
	SzablonId INT not null
	Foreign key(UserId) References AO.ExcelUsers(Id),
	Foreign key(SzablonId) References [AO].[PRP_Excel2SQL_Queries](Preg_Id)
);
GO


CREATE OR ALTER Procedure [AO].[ExcelDodajUsera] @login varchar(max), @haslo varchar(max)
AS
Insert into AO.ExcelUsers(Login, Password) VALUES (@login, @haslo)
GO

CREATE OR ALTER PROCEDURE [AO].[ExcelUsunUsera] @Id int
as
Delete from AO.User_Szablon where UserId = @Id
Delete from Ao.ExcelUsers where Id = @Id
go


CREATE OR ALTER PROCEDURE [AO].[ExcelWyswietlUserow]
as
select * from ao.ExcelUsers
GO

CREATE OR ALTER PROCEDURE AO.ExcelSprawdzCzyUzytkownikIstnieje @user varchar(max), @exist bit output
as
declare @result int = (SELECT COUNT(*) FROM AO.ExcelUsers WHERE Login = @user)

IF @result = 0
	SELECT @exist = 0
ELSE 
	SELECT @exist = 1
GO



CREATE OR ALTER PROCEDURE [AO].[ExcelZmienUsera] @Id int, @nowyLogin varchar(max) ,@noweHaslo varchar(max)
as
Update AO.ExcelUsers SET Login = @nowyLogin,Password = @noweHaslo where Id = @Id
GO

CREATE OR ALTER PROCEDURE AO.ExcelUsunSzablonDlaUsera @userId int, @szablonId int
as
DECLARE @result int = (SELECT COUNT(*) FROM AO.User_Szablon where UserId = @userId AND SzablonId = @szablonId)
	IF @result > 0
Delete from AO.User_Szablon where UserId = @userId AND SzablonId = @szablonId
GO


CREATE OR ALTER PROCEDURE AO.ExcelDodajSzablonDlaUsera @userId int, @szablonId int
AS
	DECLARE @result int = (SELECT COUNT(*) FROM AO.User_Szablon where UserId = @userId AND SzablonId = @szablonId)
	IF @result = 0 
	INSERT INTO AO.User_Szablon(UserId, SzablonId) VALUES (@userId, @szablonId)
GO

CREATE OR ALTER PROCEDURE AO.ExcelWyswietlWszystkieSzablonyUsera @userId int
as
SELECT SzablonId from ao.User_Szablon where UserId = @userId
go


CREATE OR ALTER PROCEDURE [AO].[ExcelLogowanie] @login varchar(max), @password varchar(max), @isAdmin bit output ,@result int output
as	
	DECLARE @r int = (Select COUNT(*) from ao.ExcelUsers where LOGIN = @login AND Password = @password)

	IF @r = 0
	BEGIN
	SELECT @result = 0
	SELECT @isAdmin = 0
	END
	ELSE
	Begin
	SELECT @result = (Select ID from ao.ExcelUsers where LOGIN = @login AND Password = @password)
	SELECT @isAdmin = (Select isSuperUser from ao.ExcelUsers where LOGIN = @login AND Password = @password)
	END
	GO

CREATE OR ALTER PROCEDURE [AO].[ExcelWyswietlNazwySzablonow] @userId int
as
declare @IsSuperUser bit = (SELECT IsSuperUser from ao.ExcelUsers where Id = @userId)

if @IsSuperUser = 1
BEGIN 
SELECT * FROM AO.PRP_Excel2SQL_Queries
END
ELSE
BEGIN
SELECT AO.PRP_Excel2SQL_Queries.Preg_Name FROM AO.User_Szablon 
JOIN AO.PRP_Excel2SQL_Queries ON AO.User_Szablon.SzablonId = AO.PRP_Excel2SQL_Queries.Preg_Id
where ao.User_Szablon.UserId = @userId
END
Go

CREATE OR ALTER PROCEDURE AO.ExcelWyswietlZawartoscSzablonu @szablonName varchar(max), @result varchar(max) output
as
SELECT @result = (SELECT AO.PRP_Excel2SQL_Queries.Preg_TextReg FROM AO.PRP_Excel2SQL_Queries
where ao.PRP_Excel2SQL_Queries.Preg_Name = @szablonName)
Go

CREATE OR ALTER PROCEDURE AO.ExcelDodajAdmina @login varchar(max), @password varchar(max)
as
INSERT INTO AO.ExcelUsers(Login,Password,IsSuperUser) VALUES (@login, @password,1)
go

IF OBJECT_ID('AO.ExcelUsers') IS NULL
begin 
EXEC AO.ExcelDodajTabeleUserow
end

IF OBJECT_ID('AO.PRP_Excel2SQL_Queries') IS NULL
begin 
EXEC AO.ExcelDodajTabeleSzablonow
end

IF OBJECT_ID('AO.User_Szablon') IS NULL
begin 
EXEC AO.ExcelDodajTabeleUser_Szablon
end
